//
//  AppDelegate.m
//  GDTActionSDKSample
//
//  Created by Chao Gao on 2017/11/23.
//  Copyright © 2017年 Tencent. All rights reserved.
//

#import "AppDelegate.h"
#import "GDTAction.h"
#import <Bugly/Bugly.h>
#import "StoreKit/SKAdNetwork.h"
#import <AdSupport/AdSupport.h>
#import <AppTrackingTransparency/AppTrackingTransparency.h>//适配iOS14

@interface AppDelegate ()

@end

@implementation AppDelegate

-(BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation
{
    [GDTAction logAction:GDTSDKActionNameStartApp actionParam:@{GDTSDKActionParamKeyOpenUrl:url.absoluteString}];
    return true;
}

-(BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<UIApplicationOpenURLOptionsKey,id> *)options
{
    [GDTAction logAction:GDTSDKActionNameStartApp actionParam:@{GDTSDKActionParamKeyOpenUrl:url.absoluteString}];
    return true;
    
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    
    NSLog(@"xxxxxxtest:%@",NSStringFromSelector(_cmd));
    [Bugly startWithAppId:@"efcf54ed1b"];
    
    /*
     * 在接入广点通行为数据SDK时，请在App启动的时候调用初始化方法
     * 初始化方法调用时请传入数据源UserActionSetId和在后台看到的secretKey密钥串
     */
    //[GDTAction init:@"1109608434" secretKey:@"8f12e21a94e04b0c505a24bedbf858d3"];
    [GDTAction init:@"1106262171" secretKey:@"9be5526f281752a4fda1345fee7cbc56"];
    
    //[GDTAction logAction:@"START_APP" actionParam:@{@"didFinishLaunchingWithOptions":launchOptions
    //}];
    
    return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
}


- (void)applicationDidBecomeActive:(UIApplication *)application {

    NSLog(@"xxxxxxtest:%@",NSStringFromSelector(_cmd));
    /*
     * 在应用启动的时候请上报GDTSDKActionNameStartApp行为
     * SDK内部会判断此次启动行为是否为激活行为并上报，开发者无需另外作判断逻辑
     */
    [GDTAction logAction:GDTSDKActionNameStartApp actionParam:@{}];
    
    [self requestATT];
}

- (void)requestATT {
    if (@available(iOS 14, *)) {
        // iOS14及以上版本需要先请求权限
        ATTrackingManagerAuthorizationStatus status = ATTrackingManager.trackingAuthorizationStatus;
        if (status == ATTrackingManagerAuthorizationStatusNotDetermined) {
            //用户未做选择或未弹窗
            dispatch_semaphore_t sem = dispatch_semaphore_create(0);
            [ATTrackingManager requestTrackingAuthorizationWithCompletionHandler:^(ATTrackingManagerAuthorizationStatus status) {
                if (status == ATTrackingManagerAuthorizationStatusAuthorized) {
                    //用户允许
                    NSLog(@"ATT User authorized");
                }
                dispatch_semaphore_signal(sem);
            }];
            dispatch_semaphore_wait(sem, DISPATCH_TIME_FOREVER);
        }else if(status == ATTrackingManagerAuthorizationStatusAuthorized){
            //用户允许
            NSLog(@"ATT User authorized");
        }else{
            NSLog(@"ATT User not allowed");
        }
    }
}


- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    
}


@end
