//
//  ViewController.m
//  GDTActionSDKSample
//
//  Created by Chao Gao on 2017/11/23.
//  Copyright © 2017年 Tencent. All rights reserved.
//

#import "ViewController.h"
#import "GDTAction+convenience.h"
#import <StoreKit/StoreKit.h>
#import "GDTActionBase64.h"

@interface ViewController ()
{
    NSArray *actionNames;
    NSDictionary *actionParam;
    NSArray *specialActionNames;
}
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    actionNames = @[GDTSDKActionNameApply,GDTSDKActionNameStartApp,GDTSDKActionNameAddToCart,GDTSDKActionNameSearch,GDTSDKActionNameRate,GDTSDKActionNameShare,GDTSDKActionNameConsult,GDTSDKActionNamePageView,GDTSDKActionNamePurchase,GDTSDKActionNameRegister,GDTSDKActionNameDownloadApp,GDTSDKActionNameReservation,GDTSDKActionNameViewContent,GDTSDKActionNameInitiateCheckOut,GDTSDKActionNameCompleteOrder,GDTSDKActionNameAddToWishList];
    actionParam = @{@"apply_name":@"Tencent",
                    @"is_adult":@(YES),
                    @"product_id":@"12345", //商品id，字符串类型
                    @"value":@(12000),      //金额，单位分，整数类型
                    @"favourite_items":@[@"Travelling",@"Flying",@"Shopping"],
                    
                    };
    NSError *error = nil;
    [_actionParamView setText:[self dictionaryToStr:actionParam error:error]];
    
    specialActionNames = @[@"注册", @"登录", @"绑定社交账户", @"完成教学任务", @"创建角色", @"升级", @"查看商品", @"加入购物车", @"下单", @"支付", @"添加支付渠道", @"评分", @"分享至社交网络"];
    
    [self.tableView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"GDTActionTableviewCellIdentifier"];
}

-(NSString *)dictionaryToStr:(NSDictionary *)dic error:(NSError *)error
{
    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dic options:NSJSONWritingPrettyPrinted error:&error];
    if (!error) {
        NSString *jsonStr = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
        return jsonStr;
    }
    return @"";
}

-(NSDictionary *)strToDictionary:(NSString *)str error:(NSError *)error
{
    NSData *data = [str dataUsingEncoding:NSUTF8StringEncoding];
    id jsonData = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingAllowFragments error:&error];
    if (!error && [jsonData isKindOfClass:[NSDictionary class]] ) {
        return (NSDictionary *)jsonData;
    }
    return nil;
}

- (IBAction)report:(id)sender {
    
    NSError *error = nil;
    NSDictionary *d =  [self strToDictionary:[_actionParamView text] error:error];
    if (d != nil) {
        [GDTAction logAction:[_actionNameReportView text] actionParam:d];
    } else {
        [[[UIAlertView alloc] initWithTitle:@"Param 格式错误" message:[error description] delegate:nil cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil] show];
    }
}

- (IBAction)iOS14Test:(id)sender {
    
    NSLog(@"iOS14Test");
    
    NSString *adnetworkId=@"F7S53Z58QE.skadnetwork";
    NSNumber *campaignId=@99;
    NSNumber *timeStamp=@1595922036771;
    NSNumber *itunesId=[NSNumber numberWithLong:1522422781];
    NSUUID *uuid = [[NSUUID alloc] initWithUUIDString:@"e621e1f8-c36c-495a-93fc-0c247a3e6e44"];
    NSString *sig = @"MEYCIQCjEtRzoiStP9AbCnFPg8esAJKSIxpK0OxpbXlhZnRkFQIhAJ9/dGloYfBLFpXc+X4R8StlbWyvaL/vkDCA0ihbISPL";
    
    SKStoreProductViewController *storeViewController = [[SKStoreProductViewController alloc] init];
    [self presentViewController:storeViewController animated:YES completion:nil];
    if (@available(iOS 11.3, *)) {
            [storeViewController loadProductWithParameters:@{
                //SKStoreProductParameterITunesItemIdentifier : @950191475,//专业
                SKStoreProductParameterITunesItemIdentifier : itunesId,
                SKStoreProductParameterAdNetworkAttributionSignature:sig,
                SKStoreProductParameterAdNetworkCampaignIdentifier:campaignId,
                SKStoreProductParameterAdNetworkIdentifier:adnetworkId,
                SKStoreProductParameterAdNetworkNonce:uuid,
                 SKStoreProductParameterAdNetworkTimestamp:timeStamp
                /* SKStoreProductParameterAdNetworkSourceAppStoreIdentifier:@"source app id",//ios 14
               SKStoreProductParameterAdNetworkVersion:@""*/
            } completionBlock:^(BOOL result, NSError * _Nullable error) {
                NSLog(@"load result : %@",result?@"YES":@"NO");
            }];
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView
{
    return 1;
}

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component
{
    return [actionNames count];
}

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component
{
    return actionNames[row];
}

- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
    [_actionNameReportView setText:actionNames[row]];
}

-(IBAction)textFiledReturnEditing:(id)sender {
    
    [sender resignFirstResponder];
    
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range replacementText:(NSString *)text{
    
    if ([text isEqualToString:@"\n"]) {
        [textView resignFirstResponder];
        return NO;
    }
    return YES;
}

#pragma mark -
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [specialActionNames count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"GDTActionTableviewCellIdentifier" forIndexPath:indexPath];
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"GDTActionTableviewCellIdentifier"];
    }
    cell.textLabel.text = [specialActionNames objectAtIndex:indexPath.row];
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    [self doReport:indexPath.row];
}

- (void)doReport:(NSInteger)type {
    switch (type) {
        case 0:
        {
            if (random() % 2 == 0) {
                [GDTAction reportRegisterActionWithMethod:@"QQ" isSuccess:YES];
            }
            else {
                [GDTAction reportRegisterActionWithMethod:@"wechat" isSuccess:NO];
            }
        }
            
            break;
        case 1:
        {
            if (random() % 2 == 0) {
                [GDTAction reportLoginActionWithMethod:@"QQ" isSuccess:YES];
            }
            else {
                [GDTAction reportLoginActionWithMethod:@"wechat" isSuccess:NO];
            }
            
        }
            break;
        case 2:
        {
            if (random() % 2 == 0) {
                [GDTAction reportBindSocialAccountActionWithType:@"QQ" isSuccess:YES];
            }
            else {
                [GDTAction reportBindSocialAccountActionWithType:@"wechat" isSuccess:NO];
            }

        }
            break;
        case 3:
        {
            [GDTAction reportFinishQuestActionWithQuestID:@"T1" questType:@"任务" questName:@"新手任务" questNumer:2 description:@"desc" isSuccess:YES];
        }
            break;
        case 4:
        {
            [GDTAction reportCreateRoleActionWithRole:@"青铜"];
        }
            break;
        case 5:
        {
            [GDTAction reportUpgradeLevelActionWithLevel:5];
        }
            break;
        case 6:
        {
            [GDTAction reportViewContentActionWithContentType:@"皮肤" contentName:@"皮肤皮肤皮肤" contentID:@"C009"];
        }
            break;
        case 7:
        {
            [GDTAction reportAddingToCartActionWithContentType:@"a" contentName:@"手机" contentID:@"989" contentNumber:5 isSuccess:YES];
        }
            break;
        case 8:
        {
            [GDTAction reportCheckoutActionWithContentType:@"a" contentName:@"手机" contentID:@"000" contentNumber:5 isVirtualCurrency:YES virtualCurrencyType:@"元宝" realCurrencyType:@"USD" isSuccess:YES];
        }
            break;
        case 9:
        {
            [GDTAction reportPurchaseActionWithContentType:@"aa" contentName:@"手机" contentID:@"ddd" contentNumber:5 paymentChannel:@"wechat" realCurrency:@"USD" currencyAmount:100 isSuccess:YES];
        }
            break;
        case 10:
        {
            [GDTAction reportAddPaymentChannelActionWithChannel:@"Alipay" isSuccess:NO];
        }
            break;
        case 11:
        {
            [GDTAction reportRateActionWithRate:3];
        }
            break;
        case 12:
        {
            [GDTAction reportShareActionWithChannel:@"Wechat" isSuccess:YES];
        }
            break;
        default:
            break;
    }
}

@end
